/* 
 * File:     Info.cpp
 * Author:   NMM
 * Date:     12.03.2006
 * Modified: 27.03.2006
 *
 * Purpose: Definitionen der Klasse Info
 */
 
#include "Definitions.h"
#include "Info.h"


Info::Info(){
   int i;
   
   sheep = 0;
   cadavre = 0;
   
   SP = new PaeSheep*[MAX_SHEEP];
   CP = new PaeCadavre*[MAX_SHEEP];
   for(i=0;i<MAX_SHEEP;i++){     
       SP[i] = NULL;
       CP[i] = NULL;
   }
   

}
 
Info::~Info(){
  delete(SP);
  delete(CP);
}


/*
 * Eine Info-Objekt enthaelt Schafe und Kadaver. Mit
 * dieser Funktion werden die nun bezueglich eines Wolfes
 * sortiert
 */


void Info::Sort(Wolf *me){
  int i, j;
  float v1[3], v2[3], v3[3], dist1, dist2;
  PaeSheep *temp1;
  PaeCadavre *temp2;
  bool done;

  me->GetPosition(v3);

  // Schafe sortieren //
  i = 0;
  do{
	done = true;
	for(j = i; j < sheep-1; j++){
      SP[j]->GetPosition(v1);
      SP[j+1]->GetPosition(v2);
      v1[0] -= v3[0];
      v1[1] -= v3[1];
      v1[2] -= v3[2];
      
      v1[0] -= v3[0];
      v1[1] -= v3[1];
      v1[2] -= v3[2];
      
      dist1 = PaeRenorm3(v1);
      dist2 = PaeRenorm3(v2);
      
      if(dist1 > dist2){
        temp1 = SP[j];
        SP[j] = SP[j+1];
        SP[j+1] = temp1;
		done = false;
      }
    }
	i++;
  } while(!done);
  

  // Kadaver sortieren //
  i = 0;
  do{
	done = true;
    for(j = i; j < cadavre-1; j++){
      CP[j]->GetPosition(v1);
      CP[j+1]->GetPosition(v2);
      v1[0] -= v3[0];
      v1[1] -= v3[1];
      v1[2] -= v3[2];
      
      v2[0] -= v3[0];
      v2[1] -= v3[1];
      v2[2] -= v3[2];
      
      dist1 = PaeRenorm3(v1);
      dist2 = PaeRenorm3(v2);
      
      if(dist1 > dist2){
        temp2 = CP[j];
        CP[j] = CP[j+1];
        CP[j+1] = temp2;
		done = false;
	  }
	}
	i++;
  } while(!done);

}

