/* 
 * File:    PaeSimulator.h
 * Author:  PAE
 * Date:    18.03.2006
 *
 * Purpose: Headerfile der Klasse fuer den Simulator
 */

#ifndef PAE_SIMULATOR_HEADER
#define PAE_SIMULATOR_HEADER

#include "PaeCamera.h"
#include "World.h"
#include "PaeSheep.h"

using namespace std;

#define SIMULATOR_ACTION 1
#define SIMULATOR_SLEEP  0

class PaeSimulator{
 private:

  GLenum polygonMode;
  
  GLfloat light_position[4];
  GLfloat light_ambient[4];
  GLfloat light_diffuse[4];
  GLfloat light_specular[4];

  int win_w;
  int win_h;
  float zoom;

  int flat;
  int mode;

  int visual_flag;

 public:
  
  PaeCamera *cam;    //pointer auf kamera
  World  *wor;  //pointer auf terrain

  PaeSimulator(void);

  void ToggleVisualFlag(void);


  void Display(void);
  void Reshape(int width, int height);
  void Init(int argc, char **argv);
  void Key(unsigned char key, int x, int y);
  void SpecialKey(int key, int x, int y);
  void Timer(int value);

};


#endif    /* PAE_SIMULATOR_HEADER */
