/* 
 * File:     Utilities.cpp
 * Author:   MJW
 * Date:     27.03.2006
 * Modified: 27.03.2006
 *
 * Purpose:  Hold the definition of all utilities functions
 */

#include "Utilities.h"
#include <math.h>
#include <cstdlib>
#include <iostream>
#include <cmath>

#include <GL/glut.h>

using namespace std;
 
void PaeRandSeed(void){
   srand(time(NULL));
}
 
/*
 * Function to compute a floating point random number
 * between  lower and upper
 */

float PaeRand(float lower, float upper){
  return((float)rand()/(float) RAND_MAX * (upper - lower) + lower);
}


float PaeRenorm3(float *dir){
  float l;
  
  l = dir[0]*dir[0]+dir[1]*dir[1]+dir[2]*dir[2];
  l = sqrt(l);
  
  dir[0]/= l;
  dir[1]/= l;
  dir[2]/= l;
  
  return(l);
}


float Distance(Animal *a,Animal *b){
  float pa[3],pb[3];
  float dx,dy,dz;
  
  a->GetPosition(pa);
  b->GetPosition(pb);
  dx = pa[0] - pb[0];
  dy = pa[1] - pb[1];
  dz = pa[2] - pb[2];

  return(sqrt(dx*dx+dy*dy+dz*dz));                                  
}

float Skalarprodukt(float x1, float x2, float y1, float y2){
  float zaehler = x1*y1 + x2*y2;
  float nenner = sqrt((x1*x1+x2*x2)*(y1*y1+y2*y2));

  if (nenner != 0.0){
	return(zaehler/nenner);
  } else {
	return(0.0);
  }
}


float UtilCrossProduct(float *x, float *y, float *n){

  n[0] = x[1]*y[2]-y[1]*x[2];
  n[1] = x[2]*y[0]-y[2]*x[0];
  n[2] = x[0]*y[1]-y[0]*x[1];

}


void UtilRenderString(char v[]){
  char *c_ptr;
  
  c_ptr = v;
  while (*c_ptr != '\0'){
    glutBitmapCharacter(GLUT_BITMAP_9_BY_15,*c_ptr);
    c_ptr++;
  }
}


/*
 * C++ version char* style "itoa":
 */

char* UtilItoa( int value, char* result, int base ) {

  // check that the base if valid
  if (base < 2 || base > 16) { *result = 0; return result; }

  char* out = result;
  int quotient = value;

  do {
	*out = "0123456789abcdef"[ std::abs( quotient % base ) ];
	++out;
	quotient /= base;
  } while ( quotient );

  // Only apply negative sign for base 10
  if ( value < 0 && base == 10) *out++ = '-';
  
  std::reverse( result, out );
  *out = 0;
  return result;
}



void UtilClamp(float *a, float low, float up){
  if (low > up){
	return;
  }
  *a = min(*a,up);
  *a = max(*a,low);
}

void UtilClamp(int *a, int low, int up){
  if (low > up){
	return;
  }
  *a = min(*a,up);
  *a = max(*a,low);
}
