/* 
 * File:     Wolf.cpp
 * Author:   PAE
 * Date:     27.03.2006
 * 
 *
 * Purpose: Headerdatei zur Klasse Wolf
 */



#ifndef WOLF_HEADER
#define WOLF_HEADER


#include <iostream>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include <math.h>

#include "Definitions.h"
#include "Utilities.h"
#include "World.h"
#include "Animal.h"
#include "Info.h"

using namespace std;


class World;


class Wolf: public Animal{
  public:
    float pos[3];//position
    float dir[3];//richtung nur 2d berechnung
    float up[3];//oben
    float acc[3];//beschleunigung nur 2d berechnung
	float angle; // Orientierungswinkel im Bereich [0-360]
    GLfloat col[3];      //zeichenfarbe
    GLfloat vis_col[3];  //animationsfarbe
	
    float v;
    int state;             // 
    int schlafzeit;        // wie lange der wolf noch ruht
	float jagd_instinkt;   // je hoeher, desto besser jagt der wolf

    float hunger;          // 0 = satt, 1 = sehr hungrig
    int maxausdauer;       // wie viele runden kann der wolf maximal rennen
    int ausdauer;          // wie viele runden kann der wolf noch rennen
    
    World *my_world;
    
  public:
    
    Wolf *nextwolf;
 
	// Konstruktoren
    Wolf(World *w);
    Wolf(float x, float y, World *w);

	// Explizite Modifizierer

    void SetParameters(void);
    void SetPosition(GLfloat x, GLfloat y, GLfloat z);
    void SetDirection(GLfloat x, GLfloat y, GLfloat z);
    void SetColor(GLfloat r, GLfloat g, GLfloat b);
    void SetVisColor(GLfloat r, GLfloat g, GLfloat b);

	// Implizite Modifizierer
    void Think(void);
    void Move(void);
    void Act(void);

	// Selektoren
    void GetPosition(float *p);
    void GetDirection(float *d);

    void Draw(int visual);
};


 
#endif  // WOLF_HEADER
