/* 
 * File:    World.h
 * Author:  NMM
 * Date:    12.03.2006
 *
 * Purpose: headerdatei mit definitionen der klassen simulation und sheep
 */
 
 
 
#ifndef WORLD_HEADER
#define WORLD_HEADER

#include <iostream>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include <math.h>

#include "PaeSheep.h"
#include "Terrain.h"
#include "Stone.h"
#include "Wolf.h"
#include "PaeCadavre.h"
#include "Animal.h"

class PaeSheep;

class Stone;

class Wolf;

class PaeCadavre;

class Info;

class World{
  private:
    PaeSheep *firstsheep;
    Wolf *firstwolf;
    PaeCadavre *firstcadavre;
	int number_of_sheep;
	int number_of_cadavre;

  public:
    Terrain *terr; 
	Stone *stone;

    World();
    void CreateSheep(); 
    void CreateSheep(int n); 
    void CreateWolf(); 
    void CreateWolf(int n); 
    void Draw(int visual);
    
    float GetGras(float x, float y);
    void EatGras(float x, float y);
    float GetHeight(float x, float y);   
    Info* GetInfo(PaeSheep *me);

    void step(int value);  
    void Prepare(void);   
    void Action(void);

    Stone *GetNearestStone(Animal* sheep);
    PaeSheep *GetNearestSheep(Animal* sheep);
    Wolf *GetNearestWolf(Animal* asking_animal);

    PaeSheep **GetFiveNearestSheep(Animal* sheep);

    //funktionen fuer die woelfe
    bool KillSheep(float *p);               // toete das schaf an der stelle p und 
                                            // liefert zurueck, ob das toeten gelungen ist
    
    //funktionen fuer cadaver
    void CreateCadavre(float *p);           // erstellt einen cadaver
    bool EatFlesh(float *p, float amount);  // isst fleisch vom kadaver an der stelle p und 
                                            // liefert zurueck, obs gelungen ist
    int GetNumberOfSheep(void);
    int GetNumberOfCadavre(void);
};

#endif
